/* This file was generated by plugin 'Nordic Semiconductor nRF5x v.1.2.4' (BDS version 1.1.3139.0) */

#include "ble_xxx_service.h"
#include <string.h>
#include "nordic_common.h"
#include "ble_srv_common.h"
#include "app_util.h"
#include "app_util_bds.h"

#define OPCODE_LENGTH 1 /**< Length of opcode inside xxx Service packet. */
#define HANDLE_LENGTH 2 /**< Length of handle inside xxx Service packet. */

/* TODO Consider changing the max values if encoded data for characteristic/descriptor is fixed length */ 
#define MAX_XXX_SERVICE_YYY_CHARACTERISTIC_LEN (BLE_L2CAP_MTU_DEF - OPCODE_LENGTH - HANDLE_LENGTH) /**< Maximum size of a transmitted xxx Service yyy characteristic. */ 

/**@brief Function for encoding xxx Service yyy characteristic.
 *
 * @param[in]   p_xxx_service_yyy_characteristic              xxx Service yyy characteristic characteristic structure to be encoded.
 * @param[out]  p_encoded_buffer   Buffer where the encoded data will be written.
 *
 * @return      Size of encoded data.
 */
static uint8_t xxx_service_yyy_characteristic_encode(ble_xxx_service_xxx_service_yyy_characteristic_t * p_xxx_service_yyy_characteristic, uint8_t * encoded_buffer)
{
    uint8_t len = 0; 
    len += bds_uint8_array_encode(&p_xxx_service_yyy_characteristic->thearray_field, &encoded_buffer[len]); 
    return len;
}

/**@brief Function for decoding xxx Service yyy characteristic.
 *
 * @param[in]   data_len              Length of the field to be decoded.
 * @param[in]   p_data                Buffer where the encoded data is stored.
 * @param[out]  p_write_val           Decoded data.
 *
 * @return      Length of the decoded field.
 */
static uint8_t xxx_service_yyy_characteristic_decode(uint8_t data_len, uint8_t * p_data, ble_xxx_service_xxx_service_yyy_characteristic_t * p_write_val)
{
    uint8_t pos = 0;
    pos += bds_uint8_array_decode((data_len-pos), &p_data[pos], &p_write_val->thearray_field); 

    return pos;
} 

/**@brief Function for handling the Connect event.
 *
 * @param[in]   p_xxx_service       xxx Service Service structure.
 * @param[in]   p_ble_evt   Event received from the BLE stack.
 */
static void on_connect(ble_xxx_service_t * p_xxx_service, ble_evt_t * p_ble_evt)
{
    p_xxx_service->conn_handle = p_ble_evt->evt.gap_evt.conn_handle;
}

/**@brief Function for handling the Disconnect event.
 *
 * @param[in]   p_xxx_service       xxx Service Service structure.
 * @param[in]   p_ble_evt   Event received from the BLE stack.
 */
static void on_disconnect(ble_xxx_service_t * p_xxx_service, ble_evt_t * p_ble_evt)
{
    UNUSED_PARAMETER(p_ble_evt);
    p_xxx_service->conn_handle = BLE_CONN_HANDLE_INVALID;
}

/**@brief Function for handling the Write event.
 *
 * @param[in]   p_xxx_service       xxx Service Service structure.
 * @param[in]   p_ble_evt   Event received from the BLE stack.
 */
static void on_write(ble_xxx_service_t * p_xxx_service, ble_gatts_evt_write_t * p_ble_evt)
{
    
    if(p_ble_evt->handle == p_xxx_service->xxx_service_yyy_characteristic_handles.value_handle)
    {
        if(p_xxx_service->evt_handler != NULL)
        {
            ble_xxx_service_evt_t evt;
            evt.evt_type = BLE_XXX_SERVICE_XXX_SERVICE_YYY_CHARACTERISTIC_EVT_WRITE;
            xxx_service_yyy_characteristic_decode(p_ble_evt->len, p_ble_evt->data, &evt.params.xxx_service_yyy_characteristic);
            p_xxx_service->evt_handler(p_xxx_service, &evt);
        }
    }
}

/**@brief Authorize WRITE request event handler.
 *
 * @details Handles WRITE events from the BLE stack.
 *
 * @param[in]   p_sc_ctrlpt  SC Ctrlpt structure.
 * @param[in]   p_gatts_evt  GATTS Event received from the BLE stack.
 *
 */
static void on_rw_authorize_request(ble_xxx_service_t * p_xxx_service, ble_gatts_evt_t * p_gatts_evt)
{
    ble_gatts_evt_rw_authorize_request_t * p_auth_req = &p_gatts_evt->params.authorize_request;
    if (p_auth_req->type == BLE_GATTS_AUTHORIZE_TYPE_WRITE)
    {
        if (   (p_gatts_evt->params.authorize_request.request.write.op
                != BLE_GATTS_OP_PREP_WRITE_REQ)
            && (p_gatts_evt->params.authorize_request.request.write.op
                != BLE_GATTS_OP_EXEC_WRITE_REQ_NOW)
            && (p_gatts_evt->params.authorize_request.request.write.op
                != BLE_GATTS_OP_EXEC_WRITE_REQ_CANCEL)
           )
        {
        
            if (p_auth_req->request.write.handle == p_xxx_service->xxx_service_yyy_characteristic_handles.value_handle)
            {
                on_write(p_xxx_service, &p_auth_req->request.write);
            }
        }
    }
}

/**@brief Function for handling BLE events.
 *
 * @param[in]   p_xxx_service       xxx Service Service structure.
 * @param[in]   p_ble_evt   Event received from the BLE stack.
 */
void ble_xxx_service_on_ble_evt(ble_xxx_service_t * p_xxx_service, ble_evt_t * p_ble_evt)
{
    switch (p_ble_evt->header.evt_id)
    {
        case BLE_GAP_EVT_CONNECTED:
            on_connect(p_xxx_service, p_ble_evt);
            break;
        case BLE_GAP_EVT_DISCONNECTED:
            on_disconnect(p_xxx_service, p_ble_evt);
            break;
        case BLE_GATTS_EVT_WRITE:
            on_write(p_xxx_service, &p_ble_evt->evt.gatts_evt.params.write);
            break;
         case BLE_GATTS_EVT_RW_AUTHORIZE_REQUEST:
            on_rw_authorize_request(p_xxx_service, &p_ble_evt->evt.gatts_evt);
            break;
        default:
            //No implementation needed.
            break;
    }
}

/**@brief Function for initializing the xxx Service. */
uint32_t ble_xxx_service_init(ble_xxx_service_t * p_xxx_service, const ble_xxx_service_init_t * p_xxx_service_init)
{
    uint32_t err_code;
    ble_uuid_t ble_uuid;

    // Initialize service structure
    p_xxx_service->evt_handler = p_xxx_service_init->evt_handler;
    p_xxx_service->conn_handle = BLE_CONN_HANDLE_INVALID;
    
    // Add a custom base UUID.
    ble_uuid128_t bds_base_uuid = {{0x8B, 0x61, 0x54, 0xE1, 0x45, 0xF0, 0x11, 0xAD, 0x1A, 0x42, 0x7D, 0xFB, 0x00, 0x00, 0x0D, 0xEE}};
    uint8_t       uuid_type;
    err_code = sd_ble_uuid_vs_add(&bds_base_uuid, &uuid_type);
    if (err_code != NRF_SUCCESS)
    {
        return err_code;
    }
    ble_uuid.type = uuid_type;
    ble_uuid.uuid = 0x298D;
        
    // Add service
    err_code = sd_ble_gatts_service_add(BLE_GATTS_SRVC_TYPE_PRIMARY, &ble_uuid, &p_xxx_service->service_handle);
    if (err_code != NRF_SUCCESS)
    {
        return err_code;
    } 

    // Add xxx Service yyy characteristic characteristic
    ble_xxx_service_xxx_service_yyy_characteristic_t xxx_service_yyy_characteristic_initial_value = p_xxx_service_init->ble_xxx_service_xxx_service_yyy_characteristic_initial_value; 

    uint8_t xxx_service_yyy_characteristic_encoded_value[MAX_XXX_SERVICE_YYY_CHARACTERISTIC_LEN];
    ble_add_char_params_t add_xxx_service_yyy_characteristic_params;
    memset(&add_xxx_service_yyy_characteristic_params, 0, sizeof(add_xxx_service_yyy_characteristic_params));
    
    add_xxx_service_yyy_characteristic_params.uuid                = 0xCE24;
    add_xxx_service_yyy_characteristic_params.uuid_type           = ble_uuid.type; 
    add_xxx_service_yyy_characteristic_params.max_len             = MAX_XXX_SERVICE_YYY_CHARACTERISTIC_LEN;
    add_xxx_service_yyy_characteristic_params.init_len            = xxx_service_yyy_characteristic_encode(&xxx_service_yyy_characteristic_initial_value, xxx_service_yyy_characteristic_encoded_value);
    add_xxx_service_yyy_characteristic_params.p_init_value        = xxx_service_yyy_characteristic_encoded_value; 
    add_xxx_service_yyy_characteristic_params.char_props.write    = 1; 
    add_xxx_service_yyy_characteristic_params.write_access        = SEC_OPEN; 
    // 1 for variable length and 0 for fixed length.
    add_xxx_service_yyy_characteristic_params.is_var_len          = 1; 

    err_code = characteristic_add(p_xxx_service->service_handle, &add_xxx_service_yyy_characteristic_params, &(p_xxx_service->xxx_service_yyy_characteristic_handles));
    if (err_code != NRF_SUCCESS)
    {
        return err_code;
    } 

    return NRF_SUCCESS;
}

