/* This file was generated by plugin 'Nordic Semiconductor nRF5x v.1.2.4' (BDS version 1.1.3139.0) */

#ifndef BLE_XXX_SERVICE_H__
#define BLE_XXX_SERVICE_H__

#include <stdint.h>
#include <stdbool.h>
#include "ble.h"
#include "ble_srv_common.h"
#include "app_util_bds.h"



/**@brief xxx Service event type. */
typedef enum
{ 
    BLE_XXX_SERVICE_XXX_SERVICE_YYY_CHARACTERISTIC_EVT_NOTIFICATION_ENABLED,  /**< xxx Service yyy characteristic value notification enabled event. */
    BLE_XXX_SERVICE_XXX_SERVICE_YYY_CHARACTERISTIC_EVT_NOTIFICATION_DISABLED, /**< xxx Service yyy characteristic value notification disabled event. */
    BLE_XXX_SERVICE_XXX_SERVICE_YYY_CHARACTERISTIC_EVT_WRITE, /**< xxx Service yyy characteristic write event. */
} ble_xxx_service_evt_type_t;

// Forward declaration of the ble_xxx_service_t type.
typedef struct ble_xxx_service_s ble_xxx_service_t;








/**@brief xxx Service yyy characteristic structure. */
typedef struct
{
    uint8_array_t thearray_field;
} ble_xxx_service_xxx_service_yyy_characteristic_t;

/**@brief xxx Service Service event. */
typedef struct
{
    ble_xxx_service_evt_type_t evt_type;    /**< Type of event. */
    union {
        uint16_t cccd_value; /**< Holds decoded data in Notify and Indicate event handler. */
        ble_xxx_service_xxx_service_yyy_characteristic_t xxx_service_yyy_characteristic; /**< Holds decoded data in Write event handler. */
    } params;
} ble_xxx_service_evt_t;

/**@brief xxx Service Service event handler type. */
typedef void (*ble_xxx_service_evt_handler_t) (ble_xxx_service_t * p_xxx_service, ble_xxx_service_evt_t * p_evt);

/**@brief xxx Service Service init structure. This contains all options and data needed for initialization of the service */
typedef struct
{
    ble_xxx_service_evt_handler_t     evt_handler; /**< Event handler to be called for handling events in the xxx Service Service. */
    ble_xxx_service_xxx_service_yyy_characteristic_t ble_xxx_service_xxx_service_yyy_characteristic_initial_value; /**< If not NULL, initial value of the xxx Service yyy characteristic characteristic. */ 
} ble_xxx_service_init_t;

/**@brief xxx Service Service structure. This contains various status information for the service.*/
struct ble_xxx_service_s
{
    ble_xxx_service_evt_handler_t evt_handler; /**< Event handler to be called for handling events in the xxx Service Service. */
    uint16_t service_handle; /**< Handle of xxx Service Service (as provided by the BLE stack). */
    ble_gatts_char_handles_t xxx_service_yyy_characteristic_handles; /**< Handles related to the xxx Service yyy characteristic characteristic. */
    uint16_t conn_handle; /**< Handle of the current connection (as provided by the BLE stack, is BLE_CONN_HANDLE_INVALID if not in a connection). */
};

/**@brief Function for initializing the xxx Service.
 *
 * @param[out]  p_xxx_service       xxx Service Service structure. This structure will have to be supplied by
 *                          the application. It will be initialized by this function, and will later
 *                          be used to identify this particular service instance.
 * @param[in]   p_xxx_service_init  Information needed to initialize the service.
 *
 * @return      NRF_SUCCESS on successful initialization of service, otherwise an error code.
 */
uint32_t ble_xxx_service_init(ble_xxx_service_t * p_xxx_service, const ble_xxx_service_init_t * p_xxx_service_init);

/**@brief Function for handling the Application's BLE Stack events.*/
void ble_xxx_service_on_ble_evt(ble_xxx_service_t * p_xxx_service, ble_evt_t * p_ble_evt);

#endif //_BLE_XXX_SERVICE_H__
